
        IEN0     DATA 0A8H
        P4       DATA 0E8H
        P5       DATA 0F8H
        IP0  DATA 0A9H
        IP1  DATA 0B9H

        ORG      0000H
        sjmp     st386
        org      0003H
        ljmp     KEY
        org      000Bh
        ljmp     TIMER


st386:   mov IEN0,#81H
         mov TMOD,#11h
         mov IP0,#02h
         mov DPTR,#FONT
         mov SP,#60H
         mov A,#00H
         mov 38H,A
         mov 37H,A
         mov 36H,A
         mov 35H,A


DISPL:   mov R4,#0FEH
         mov R0,#35H
NXT:     mov A,@R0
         mov P4,#0FFH
         movc A,@A+DPTR
         mov P5,A
         mov A,R4
         mov P4,A
         rl A
         mov R4,A
         inc R0
         mov R1,#10
ST_2:    mov R2,#20
ST_1:    djnz R2,ST_1
         djnz R1,ST_2
         cjne R0,#39H,NXT
         ljmp DISPL

FONT: DB 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,88H,83H,0C6H,0A1H,86H,8Eh
TAB:    DW 1880,1772,1668,1576,1484,1400,1302,1244,1172,1120,1057,996
        DW 940,886,834,788,742,700,651,622,586,560,528,448
        DW 470,443,417,384,371,350,325,311,293,280,264,224,65535


KEY:     clr IEN0.0
         push PSW
         push ACC
         push P4
         setb PSW.3

SCAN:    mov R4,#00
         mov R7,#04
         mov R6,#0FEH
LOOP:    mov A,R6
         mov P4,A
         rl A
         mov R6,A
         mov A,P4
         mov R5,#04
         swap A
ROTATE:  rrc A
         jnc DBNC
         inc R4
         djnz R5,ROTATE
         djnz R7,LOOP
         jmp QUIT

DBNC:   lcall DELAY
        mov   A,#0F0H
        setb  IEN0.1
        setb  TR0
        setb  TF0
W_O:    mov   P4,#0F0H
        cjne A,P4,W_O
        clr  TR0
        clr   IEN0.1
        lcall DELAY
        mov   a,R4
        mov 38H,37H
        mov 37H,36H
        mov 36H,35H
        mov 35H,R4

        jmp QUIT


QUIT:   setb IEN0.0
        pop P4
        pop ACC
        pop PSW
        reti

DELAY:  mov R2,#0AH
M3:     mov R3,#55H
M4:     djnz R3,M4
        djnz R2,M3
        ret

TIMER:
        push    acc
        push    dpl
        push    dph
        cpl     p1.0
        mov     dptr,#TAB
        mov     a,R4
        add     a,acc
        push    acc
        movc    a,@a+dptr
        mov     b,a
        mov     a,#255
        subb    a,b
        mov     th0,a
        pop     acc
        inc     a
        movc    a,@a+dptr
        mov     b,a
        mov     a,#255
        subb    a,b
        mov     tl0,a
        setb    TR0
        pop     dph
        pop     dpl
        pop     acc
        reti

        END
        IEN0     DATA 0A8H
        P4       DATA 0E8H
        P5       DATA 0F8H
        IP0  DATA 0A9H
        IP1  DATA 0B9H

        ORG      0000H
        SJMP     ST386
        ORG      0003H
        LJMP     KEY
        ORG      000BH
        LJMP     L


ST386:   MOV IEN0,#81H
         MOV TMOD,#11H
         MOV IP0,#02H
         MOV DPTR,#FONT
         MOV SP,#60H
         MOV A,#00H
         MOV 38H,A
         MOV 37H,A
         MOV 36H,A
         MOV 35H,A


DISPL:   MOV R4,#0FEH
         MOV R0,#35H
NXT:     MOV A,@R0
         MOV P4,#0FFH
         MOVC A,@A+DPTR
         MOV P5,A
         MOV A,R4
         MOV P4,A
         RL A
         MOV R4,A
         INC R0
         MOV R1,#10
ST_2:    MOV R2,#20
ST_1:    DJNZ R2,ST_1
         DJNZ R1,ST_2
         CJNE R0,#39H,NXT
         LJMP DISPL

FONT: DB 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,88H,83H,0C6H,0A1H,86H,8EH
TAB:    DW 1880,1772,1668,1576,1484,1400,1302,1244,1172,1120,1057,996
        DW 940,886,834,788,742,700,651,622,586,560,528,448
        DW 470,443,417,384,371,350,325,311,293,280,264,224,65535


KEY:     CLR IEN0.0
         PUSH PSW
         PUSH ACC
         PUSH P4
         SETB PSW.3

SCAN:    MOV R4,#00
         MOV R7,#04
         MOV R6,#0FEH
LOOP:    MOV A,R6
         MOV P4,A
         RL A
         MOV R6,A
         MOV A,P4
         MOV R5,#04
         SWAP A
ROTATE:  RRC A
         JNC DBNC
         INC R4
         DJNZ R5,ROTATE
         DJNZ R7,LOOP
         JMP QUIT

DBNC:   LCALL DELAY
        MOV   A,#0F0H
        ;SETB  IEN0.1
        ;SETB  TF0
W_O:    MOV   P4,#0F0H
        CJNE A,P4,W_O
        ;CLR  TR0
        ;CLR   IEN0.1
        LCALL DELAY
        MOV   A,R4
        MOV A,#09
        SUBB A,R4
        JC FUNC
        MOV 38H,37H
        MOV 37H,36H
        MOV 36H,35H
        MOV 35H,R4

        JMP QUIT

FUNC:   CJNE R4,#0EH,G1
        LCALL PROG_1
G1:     CJNE R4,#0FH,QUIT
        LCALL PROG_2

QUIT:   SETB IEN0.0
        POP P4
        POP ACC
        POP PSW
        RETI

DELAY:  MOV R2,#0AH
M3:     MOV R3,#55H
M4:     DJNZ R3,M4
        DJNZ R2,M3
        RET

PROG_1: SETB  IEN0.1
        MOV TMOD,#11H
        MOV TH0,#00H
        MOV TL0,#00H
L1:     SETB TF0
        MOV R2,#0FfH
L3:     MOV R3,#0FFH
L2:     DJNZ R3,L2
        DJNZ R2,L3
        JMP L1
        RET

L:      CPL P1.0
        SETB TR0
        RETI

PROG_2: CLR TR0
        CLR TF0
        CLR   IEN0.1
        RET

TIMER:
        PUSH    ACC
        PUSH    DPL
        PUSH    DPH
        CPL     P1.0
        MOV     DPTR,#TAB
        MOV     A,R4
        ADD     A,ACC
        PUSH    ACC
        MOVC    A,@A+DPTR
        MOV     B,A
        MOV     A,#255
        SUBB    A,B
        MOV     TH0,A
        POP     ACC
        INC     A
        MOVC    A,@A+DPTR
        MOV     B,A
        MOV     A,#255
        SUBB    A,B
        MOV     TL0,A
        SETB    TR0
        POP     DPH
        POP     DPL
        POP     ACC
        RETI

        END