IEN0 DATA 0A8H
P4 DATA 0E8H
P5 DATA 0F8H
ORG 0000H
SJMP BEG
ORG 0003H
SJMP KEY


BEG:     MOV IEN0,#81H
         MOV DPTR,#TAB_COD_S
         SETB PSW.3
         MOV R0,#80H
         CLR PSW.3
         MOV SP,#60H
         MOV A,#00H
         MOV 39H,A
         MOV 38H,A
         MOV 37H,A
         MOV 36H,A
         MOV 35H,A

DISPL:   MOV R4,#0FEH
         MOV R0,#35H
NXT:     MOV A,@R0
         MOV P4,#0FFH
         MOVC A,@A+DPTR
         MOV P5,A
         MOV A,R4
         MOV P4,A
         RL A
         MOV R4,A
         INC R0
         MOV R1,#10
ST_2:    MOV R2,#20
ST_1:    DJNZ R2,ST_1
         DJNZ R1,ST_2
         CJNE R0,#39H,NXT
         LJMP DISPL

TAB_COD_S: DB 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,88H,83H,0C6H,0A1H,86H,8Eh,0BFH
         ;     0    1     2    3   4   5   6   7    8   9   10  11  12   13  14   15  16
KEY:     CLR IEN0.0
         PUSH PSW
         PUSH ACC
         PUSH P4
         SETB PSW.3

SCAN:    MOV R4,#00
         MOV R7,#04
         MOV R6,#0FEH
LOOP:    MOV A,R6
         MOV P4,A
         RL A
         MOV R6,A
         MOV A,P4
         MOV R5,#04
         SWAP A
ROTATE:  RRC A
         JNC DBNC
         INC R4
         DJNZ R5,ROTATE
         DJNZ R7,LOOP
         JMP QUIT

DBNC:   LCALL DELAY
        MOV A,#0F0H
W_O:    MOV P4,#0F0H
        CJNE A,P4,W_O
        LCALL DELAY
        MOV A,#09
        SUBB A,R4
        JC FUNC
        MOV 38H,37H
        MOV 37H,36H
        MOV 36H,35H
        MOV 35H,R4
        JMP QUIT

FUNC:   CJNE R4,#0AH,G1
        LCALL PROC_1
G1:     CJNE R4,#0BH,G2
        LCALL ZAP32
G2:     CJNE R4,#0CH,G3
        LCALL C5
G3:     CJNE R4,#0DH,G4
        LCALL READ
G4:     CJNE R4,#0EH,G5
        LCALL WRDIS
G5:     CJNE R4,#0FH,QUIT
        LCALL SBROS

QUIT:   SETB IEN0.0
        POP P4
        POP ACC
        POP PSW
        RETI

DELAY:  MOV R2,#0AH
M3:     MOV R3,#55H
M4:     DJNZ R3,M4
        DJNZ R2,M3
        RET

PROC_1: MOV A,#00H
        MOV 38H,A
        MOV 37H,A
        MOV 36H,A
        MOV 35H,A
        RET

C5:     LCALL UST_0
        MOV A,#0F9H
        LCALL ZAP_K
        LCALL ZAP_D
        RET

ZAP_K:  MOV R3,#08H
L3:     SETB P1.0
        CLR P1.0
        LCALL DEL12
        RRC A
        JNC NUL
        SETB P1.0
        JMP CIKL
NUL:    CLR P1.0
CIKL:   LCALL DEL60
        SETB P1.0
        DJNZ R3,L3
        RET

ZAP_D:  MOV R1,#79H
C3:     INC R1
        MOV A,@R1
        LCALL ZAP_K
        CJNE R1,#98H,C3
        RET

ZAP32:  MOV @R0,35H
        INC R0
        MOV @R0,36H
        INC R0
        MOV @R0,37H
        INC R0
        MOV @R0,38H
        INC R0
        CJNE R0,#98H,L5
        MOV R0,#80H
        MOV 35H,#16
        MOV 36H,#16
        MOV 37H,#16
        MOV 38H,#16
        LCALL C5               
L5:     RET

UST_0:  MOV R3,#42H
C7:     MOV R4,#04H
C2:     SETB P1.0
        CLR P1.0
        LCALL DEL12
        LCALL DEL60
        SETB P1.0
        DJNZ R4,C2
        DJNZ R3,C7
        RET

DEL12:  MOV R2,#04H
M5:     DJNZ R2,M5
        RET

DEL60:  MOV R2,#23H
M7:     DJNZ R2,M7
        RET

READ:   LCALL UST_0
        MOV A,#79H
        LCALL ZAP_K
        MOV R1,#79H
CIK:    INC R1
        MOV R6,#08H
C4:     SETB P1.0
        CLR P1.0
        LCALL DEL12
        SETB P1.0
        MOV C,P1.0
        RRC A
        LCALL DEL60
        DJNZ R6,C4
        MOV @R1,A
        CJNE R1,#98H,CIK
        LCALL WRDIS
        RET

WRDIS:  MOV 35H,@R0
        INC R0
        MOV 36H,@R0
        INC R0
        MOV 37H,@R0
        INC R0
        MOV 38H,@R0
        INC R0
        CJNE R0,#98H,L7
	MOV R0,#80H
L7:     RET

SBROS:  MOV R0,#80H
L9:	MOV @R0,#00H
        INC R0
        MOV @R0,#00H
        INC R0
        MOV @R0,#00H
        INC R0
        MOV @R0,#00H
        INC R0
        CJNE R0,#98H,L9
        MOV R0,#80H
        LCALL PROC_1
        RET
END
