;Ŀ
;Control motor
;DEC version  
;
;--------------------------------------------------------------------------
P4      DATA 0e8h
P5      DATA 0f8h
IEN0    DATA 0A8h
IEN1    DATA 0B8h
IP0     DATA 0A9h
IP1     DATA 0B9h
NO_INT  EQU  000h
EN_INT  EQU  08Ah
;--------------------------------------------------------------------------
        org  0000h
        ljmp BEGIN
        org  000Bh
        ljmp TIM0
        org  001Bh
        ljmp TIM1

BEGIN:
        mov  R1, #00h
        mov  SP, #60h
        mov  46h, #00h
        mov  47h, #00h
        mov  48h, #00h
        mov  49h, #00h
        mov  50h, #00h
        mov  51h, #00h
        mov  52h, #00h

        mov  IEN0, #EN_INT
        mov  IP0, #08h
        mov  IP1, #08h
        mov  TMOD, #16h
        mov  TL0, #0E8h
        mov  TH0, #0E8h
        mov  TL1, #0F0h
        mov  TH1, #0D8h
        clr  P3.5
        mov  DPTR, #FONT
        mov  TCON, #50h

IND:
        mov  R4, #0FEh
        mov  R0,#46h
NXT:    mov  A, @R0
        mov  P4, #0FFh
        movc A, @A+DPTR
        mov  P5, A
        mov  A, R4
        mov  P4, A
        rl   A
        mov  R4, A
        inc  R0
        mov  R5,#10
ST_2:   mov  R2,#20
ST_1:   djnz R2,ST_1
        djnz R5,ST_2
        cjne R0, #4Ah, NXT
        ljmp IND

TIM0:
        inc  50h
        reti

TIM1:
        push PSW
        push ACC
        mov  IEN0, #NO_INT

        inc  R1
        cjne R1, #100, EX_TIM1
        mov  46h, #00h
        mov  47h, #00h
        mov  48h, #00h
        mov  49h, #00h
        mov  R1, #00h
        mov  A, 50h
        mov  B, #3Ch
        mul  AB

       setb PSW.3
       clr PSW.4

       mov  R0,#46h
       mov  R2,b
       mov  R3,a
       mov  a,R2
k1:
       mov  b,#10
       div  ab
       mov  35h,a
       mov  a,R3
       anl  a,#0F0h
       swap a
       mov  R4,a
       mov  a,b
       swap a
       add  a,R4
       mov  b,#10
       div  ab
       mov  36h,a
       mov  a,R3
       anl  a,#0Fh
       mov  R4,a
       mov  a,b
       swap a
       orl  a,R4
       mov  b,#10
       div  ab
       mov  37h,a
       mov  @R0,b
       inc  R0
       mov  a,36h
       swap a
       orl  a,37h
       mov  R3,a
       mov  a,35h
       mov  R2,a
       jnz  k1
       mov  a,R3
       mov  b,#10
       div  ab
       mov  @R0,b
       inc  R0
       mov  R4,a
       mov  b,#10
       div  ab
       jnz  k2
       mov  a,R4
       mov  @R0,a
       sjmp K3
k2:
       mov @R0,a
       inc R0
       mov @R0,a
k3:
        mov  50h, #00h
EX_TIM1:
        mov  IEN0, #EN_INT
        pop  ACC
        pop  PSW
        mov  TL1, #0F0h
        mov  TH1, #0D8h
        reti

FONT:db 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,88H,83H,0C6H,0A1H,86H,8Eh

QUIT:
        END